//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
{$WARN SYMBOL_PLATFORM OFF}
{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  wtH_̃vWFNgSĎIɃRpC
//
//  []
//  \[Xt@C(res)ȂvWFNg̓RpCs
//  Delphi XE2ȍ~ł̓jbgXR[vȂƃRpCłȂꍇ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2007N1130 JpɐDȉȗDTCg̋LQ
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit CommandLineCompileUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, AppEvnts, Generics.Collections,
  Generics.Defaults;

type
  TDelphiVerInfo = record
    ProductVer  : Double;
    AppFullPath : string;
    RegKeyBase  : string;
    VersionStr  : string;
    Enable64bit : Boolean;
  end;

  TForm1 = class(TForm)
    TabControl1: TTabControl;
    Panel1: TPanel;
    btnFolder: TButton;
    btnCancel: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    btnEditLibPath: TButton;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Memo1: TMemo;
    Panel3: TPanel;
    Label1: TLabel;
    ProgressBar1: TProgressBar;
    OpenDialog1: TOpenDialog;
    ApplicationEvents1: TApplicationEvents;
    btnClearConfig: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnEditLibPathClick(Sender: TObject);
    procedure btnFolderClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ApplicationEvents1Message(var Msg: tagMSG; var Handled: Boolean);
    procedure btnClearConfigClick(Sender: TObject);
  private
    { Private 錾 }
    FCancelFlag : Boolean;
    procedure GetdprFilesListAll(APath: string; FileList:TStringList);
    function CreateCommandLineStr(dccPath: string; ProjName: string): string;
    procedure ControlsEnabled(WC: TWinControl; Flag : Boolean);
    function ComplieProject(dccPath: string; FileList: TStringList): Integer;
  public
    { Public 錾 }
    FIniFileName : string;
    procedure SetDefaultLibPath(TabName, ConfigFileName: string; SL: TStringList);
  end;

  procedure GetDelphiVerList(AList: TList<TDelphiVerInfo>);
  function Is64bitWindows: Boolean;

var
  Form1: TForm1;

implementation

uses
  IniFiles,
  Registry,
  FileCtrl,
  Types,
  IOUtils,
  ShlObj,
  ShellAPI,
  StrUtils,
  EditLibraryPath,
  plCommandRedirect;

//ChangeWindowMessageFilter֐p̒萔
const
  MSGFLT_ADD        = 1;
  MSGFLT_REMOVE     = 2;
  WM_COPYGLOBALDATA = $0049;

{$R *.dfm}

//=============================================================================
//  
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LFuncFilter : function (msg: Cardinal; dwFlag: DWORD): BOOL; stdcall;
  LDLLHandle  : THandle;
  LIniFile    : TIniFile;
  LFormLeft   : Integer;
  LDelphiList : TList<TDelphiVerInfo>;
  LDelphiInfo : TDelphiVerInfo;
  LIndex      : Integer;
  LAppKeyLib  : string;
  LdccexePath : string;
  LIniTabName : string;
  LTabName    : string;
begin
  //---------------------------------------------------------------------------
  //  [U[C^[tFCX̕ (UIPI)΍
  //  ႢŎsAv(GNXv[)̃hbO&hbvt
  //  Windows Vistaȍ~p
  //  ֐ChangeWindowMessageFilteŕCWindows XPȑOɂ͂Ȃ̂GetProcAddress
  //  ŊmFKv
  //---------------------------------------------------------------------------
  if CheckWin32Version(6, 0) then begin
    LDLLHandle := loadLibrary('user32.dll');
    try
      if LDLLHandle > 0 then begin
        @LFuncFilter := GetProcAddress(LDLLHandle, 'ChangeWindowMessageFilter');
        if @LFuncFilter <> nil then begin
          LFuncFilter(WM_DROPFILES,      MSGFLT_ADD);
          LFuncFilter(WM_COPYDATA,       MSGFLT_ADD);
          LFuncFilter(WM_COPYGLOBALDATA, MSGFLT_ADD);
        end;
      end;
    finally
      FreeLibrary(LDLLHandle);
    end;
  end;


  btnCancel.Enabled := False;

  Label1.Caption       := '';
  ProgressBar1.Visible := False;
  Memo1.ReadOnly       := True;
  Memo1.Lines.Clear;


  FIniFileName := ChangeFileExt(Application.ExeName, '.ini');
  LIniFile := TIniFile.Create(FIniFileName);
  try
    LFormLeft := 0;
    LTabName  := '';
    if FileExists(FIniFileName) then begin
      LIniTabName := LIniFile.ReadString ('Common', 'TabName',   '');
      LFormLeft   := LIniFile.ReadInteger('Common', 'FormLeft',   0);
      Self.Top    := LIniFile.ReadInteger('Common', 'FormTop',    Top);
      Self.Width  := LIniFile.ReadInteger('Common', 'FormWidth',  Width);
      Self.Height := LIniFile.ReadInteger('Common', 'FormHeight', Height);

      CheckBox1.Checked := LIniFile.ReadBool('Common', 'Checkbox1', False);
      CheckBox2.Checked := LIniFile.ReadBool('Common', 'Checkbox2', False);
      CheckBox3.Checked := LIniFile.ReadBool('Common', 'Checkbox3', True);
      CheckBox4.Checked := LIniFile.ReadBool('Common', 'Checkbox4', True);
    end;
  finally
    FreeAndNil(LIniFile);
  end;

  if LFormLeft = 0 then begin
    Self.Position := poMainFormCenter;
  end else begin
    Self.Position := poDesigned;
    Self.Left := LFormLeft;
  end;

  if TabControl1.Tabs.Count = 0 then begin
    //Delphi̊eo[W̏擾
    //擾͓ŊmۂĂ̂Ql̂߂Init@Cɕۑ
    //̐ݒInit@CǂݍŎgp
    LDelphiList := TList<TDelphiVerInfo>.Create;
    GetDelphiVerList(LDelphiList);

    LIniFile := TIniFile.Create(FIniFileName);
    try
      TabControl1.TabHeight := 23;
      TabControl1.TabWidth  := 120;

      for LDelphiInfo in LDelphiList do begin
        LdccexePath := ExtractFilePath(LDelphiInfo.AppFullPath);
        LAppKeyLib  := LDelphiInfo.RegKeyBase + '\Library';

        if LDelphiInfo.Enable64bit then begin
          LTabName := LDelphiInfo.VersionStr + ' (32)';
          TabControl1.Tabs.Add(LTabName);
          LIniFile.WriteString(LTabName, 'dcc32exePath', LdccexePath + 'dcc32.exe');
          LIniFile.WriteString(LTabName, 'AppKeyLib', LAppKeyLib + '\Win32');
          LIniFile.WriteFloat(LTabName, 'ProductVer', LDelphiInfo.ProductVer);

          if Is64bitWindows then begin
            LTabName := LDelphiInfo.VersionStr + ' (64)';
            TabControl1.Tabs.Add(LTabName);
            LIniFile.WriteString(LTabName, 'dcc32exePath', LdccexePath + 'dcc64.exe');
            LIniFile.WriteString(LTabName, 'AppKeyLib', LAppKeyLib + '\Win64');
            LIniFile.WriteFloat(LTabName, 'ProductVer', LDelphiInfo.ProductVer);
          end;
        end else begin
          LTabName := LDelphiInfo.VersionStr;
          TabControl1.Tabs.Add(LTabName);
          LIniFile.WriteString(LTabName, 'dcc32exePath', LdccexePath + 'dcc32.exe');
          LIniFile.WriteString(LTabName, 'AppKeyLib', LAppKeyLib);
          LIniFile.WriteFloat(LTabName, 'ProductVer', LDelphiInfo.ProductVer);
        end;
      end;
    finally
      FreeAndNil(LIniFile);
      FreeAndNil(LDelphiList);
    end;
  end;

  if TabControl1.Tabs.Count = 0 then begin
    ControlsEnabled(Panel1, False);
  end else begin
    LIndex := TabControl1.Tabs.IndexOf(LIniTabName);
    if LIndex < 0 then LIndex := 0;
    TabControl1.TabIndex := LIndex;
    TabControl1Change(nil);

    //hbOAhhbv
    //usesShellAPIKv
    DragAcceptFiles(Memo1.Handle, True);
    DragAcceptFiles(Panel1.Handle, True);
  end;
end;

//=============================================================================
//  tH[鎞́CtH[̈ʒuƃTCYinit@Cɕۑ
//=============================================================================
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  LIniFile : TIniFile;
  LTabName : string;
  LStrList : TStringList;
  LIndex   : Integer;
begin
  if TabControl1.Tabs.Count = 0 then begin
    LTabName := '';
  end else begin
    LTabName := TabControl1.Tabs[TabControl1.TabIndex];
  end;

  LIniFile := TIniFile.Create(FIniFileName);
  LStrList := TStringList.Create;
  try
    //Init@CCommonȊÕZNV
    LIniFile.ReadSections(LStrList);
    for LIndex := LStrList.Count - 1 downto 0 do begin
      if LStrList[LIndex] = 'Common' then continue;
      LIniFile.EraseSection(LStrList[LIndex]);
    end;

    LIniFile.WriteString ('Common', 'TabName',    LTabName);
    LIniFile.WriteInteger('Common', 'FormTop',     Self.Top);
    LIniFile.WriteInteger('Common', 'FormLeft',    Self.Left);
    LIniFile.WriteInteger('Common', 'FormWidth',   Self.Width);
    LIniFile.WriteInteger('Common', 'FormHeight',  Self.Height);
  finally
    FreeAndNil(LIniFile);
    FreeAndNil(LStrList);
  end;
end;

//=============================================================================
//  [pXҏW]
//  RpCɎgp郉CũpX̕ҏW
//  Őݒ肵Ȃꍇ́C$(DELPHI)Lib܂$(BDS)dcc32.cfg̐ݒ݂̂g
//  p邱ƂɂȂ
//=============================================================================
procedure TForm1.btnEditLibPathClick(Sender: TObject);
begin
  Form2 := TForm2.Create(Self);
  try
    Form2.ShowModal;
    Update;
  finally
    FreeAndNil(Form2);
  end;
end;

//=============================================================================
//  [tH_w]
//  tH_IăRpCJn
//  R}hC̎sɂ́CTvvOW[552_R}hC̃_C
//  Ng]ō쐬jbgCommandRedirectgp
//
//  ItH_dprt@CăRpC
//  RpC̃IvVCreateCommandLineStr\bhō쐬
//  \[X(.res)ȂvWFNg̓RpCłȂ
//=============================================================================
procedure TForm1.btnFolderClick(Sender: TObject);
var
  LFileDlg    : TFileOpenDialog;
  LIniFile    : TIniFile;
  LTabName    : string;
  LBasePath   : string;
  LdccexePath : string;
  LFileList   : TStringList;
begin
  LIniFile := TIniFile.Create(FIniFileName);
  LTabName := TabControl1.Tabs[TabControl1.TabIndex];

  //OĨtH_tH_
  LBasePath   := '';
  LdccexePath := '';

  try
    if FileExists(FIniFileName) then begin
      LBasePath := LIniFile.ReadString('Common', 'BasePath', '');
      if LIniFile.SectionExists(LTabName) then begin
        LdccexePath := LIniFile.ReadString(LTabName, 'dcc32exePath', '');
      end;
    end;

    if LBasePath = '' then begin
      LBasePath := ExtractFileDir(Application.ExeName);
    end;

    if not FileExists(LdccexePath) then begin
      ShowMessage('R}hCRpC܂D');
    end else begin
      //Windows Vistaȏ̏ꍇ
      if CheckWin32Version(6, 0) then begin
        LFileDlg := TFileOpenDialog.Create(Self);
        try
          LFileDlg.Options := [fdoPickFolders, fdoForceFileSystem];
          LFileDlg.DefaultFolder := LBasePath;
          LFileDlg.FileName      := LBasePath;
          if LFileDlg.Execute then begin
            Update;
            LBasePath := LFileDlg.FileName;

            LFileList := TStringList.Create;
            try
              GetdprFilesListAll(IncludeTrailingPathDelimiter(LBasePath), LFileList);
              ComplieProject(LdccexePath, LFileList)
            finally
              FreeAndNil(LFileList);
            end;
          end;
        finally
          FreeAndNil(LFileDlg);
        end;
      end else begin
        if FileCtrl.SelectDirectory('ΏۃtH_w',  '', LBasePath) then begin
          LIniFile.WriteString('Common', 'BasePath', LBasePath);

          LFileList := TStringList.Create;
          try
            GetdprFilesListAll(IncludeTrailingPathDelimiter(LBasePath), LFileList);
            ComplieProject(LdccexePath, LFileList)
          finally
            FreeAndNil(LFileList);
          end;
        end;
      end;
    end;
    LIniFile.WriteString('Common', 'BasePath', LBasePath);
  finally
    FreeAndNil(LIniFile);
  end;
end;

//=============================================================================
//  eDelphĩo[W̃CunXi[t@C폜
//=============================================================================
procedure TForm1.btnClearConfigClick(Sender: TObject);
var
  LDir      : string;
  LFileList : TStringDynArray;
  LCFGFile  : string;
  LTabName  : string;
  LIndex    : Integer;
begin
  LTabName  := TabControl1.Tabs[TabControl1.TabIndex];
  LDir      := ExtractFileDir(Application.ExeName);
  LFileList := TDirectory.GetFiles(LDir, '*.CFG', TSearchOption.soTopDirectoryOnly);
  for LIndex := 0 to Length(LFileList) - 1 do begin
    LCFGFile := LFileList[LIndex];
    if ContainsText(LCFGFile, LTabName) then Continue;
    if FileExists(LCFGFile) then begin
      DeleteFile(LCFGFile);
    end;
  end;
end;

//=============================================================================
//  GNXv[̃t@C̃hbOEhbv
//=============================================================================
procedure TForm1.ApplicationEvents1Message(var Msg: tagMSG;
  var Handled: Boolean);
var
  LCount      : Integer;
  LBuffer     : array [0..MAX_PATH - 1] of Char;
  LPath       : string;
  LIniFile    : TIniFile;
  LTabName    : string;
  LdccexePath : string;
  LFileList   : TStringList;
  LCmdExeName : WideString;
  LCmdLine    : TplCommandRedirect;
  LFileCount  : Integer;
  LCheckFlag  : Boolean;
  LIndex      : Integer;
begin
  LCmdExeName := '';

  if Msg.message =WM_DROPFILES then begin
    LCheckFlag := CheckBox1.Checked;

    if (FindDragTarget(Msg.pt, False) = Memo1) or
       (FindDragTarget(Msg.pt, False) = Panel1) then begin

      LFileList := TStringList.Create;
      LFileList.Sorted := True;
      Memo1.Clear;
      Memo1.Update;
      try
        try
          LCount       := DragQueryFile(Msg.wParam, High(DWORD), nil, 0);
          LFileCount := 0;
          for LIndex := 0 to LCount - 1 do begin
            DragQueryFile(Msg.WParam, LIndex, LBuffer, MAX_PATH);
            LPath := LBuffer;
            if UpperCase(ExtractFileExt(LPath)) = '.DPR' then begin
              //dpr̃hbOAhhbv̎EXEĂRpC
              CheckBox1.Checked := False;
              LFileList.Add(LPath);
            end else
            if UpperCase(ExtractFileExt(LPath)) = '.EXE' then begin
              //CreataeProcessStartupInfodwFlagsSTARTF_USESHOWWINDOWw
              //Ă̂cmd.exeKv
              LCmdExeName := 'cmd.exe /c ' + LPath;
              inc(LFileCount);
            end else
            if SysUtils.DirectoryExists(LPath) then begin
              GetdprFilesListAll(IncludeTrailingPathDelimiter(LPath), LFileList);
            end;
          end;
        finally
          //hbvƂ`
          DragFinish(msg.WParam);
        end;

        if LCmdExeName <> '' then begin
          if LFileCount > 1 then begin
            ShowMessage('EXEt@C1sł܂D');
          end else begin
            Screen.Cursor := crHourGlass;
            LCmdLine      := TplCommandRedirect.Create;
            try
              Memo1.Text := LCmdLine.GrabStdOutText(LCmdExeName);
            finally
              LCmdLine.Free;
              Screen.Cursor := crDefault;
            end;
          end;
        end else begin;
          LIniFile := TIniFile.Create(FIniFileName);
          LTabName := TabControl1.Tabs[TabControl1.TabIndex];

          LdccexePath := '';
          try
            if FileExists(FIniFileName) then begin
              if LIniFile.SectionExists(LTabName) then begin
                LdccexePath := LIniFile.ReadString(LTabName,'dcc32exePath','');
              end;
            end;

            if not FileExists(LdccexePath) then begin
              ShowMessage('R}hCRpC܂D');
            end else begin
              ComplieProject(LdccexePath, LFileList)
            end;
          finally
            FreeAndNil(LIniFile);
          end;
        end;
      finally
        FreeAndNil(LFileList);
      end;
    end;
    CheckBox1.Checked := LCheckFlag;
  end;
end;

//-----------------------------------------------------------------------------
//  APathdprt@CCTutH_܂߂čċAIɌ
//  tpXŎ擾FileListɊi[
//  CheckBox1`FbNĂꍇexe쐬ς݂̃vWFNgO
//-----------------------------------------------------------------------------
procedure TForm1.GetdprFilesListAll(APath: string; FileList: TStringList);
var
  LFileList : TStringDynArray;
  LexeName  : string;
  LLoopCnt  : Integer;
begin
  LFileList := TDirectory.GetFiles(APath, '*.dpr', TSearchOption.soAllDirectories);
  for LLoopCnt := 0 to Length(LFileList) - 1 do begin
    if CheckBox1.Checked then begin
      LexeName := ChangeFileExt(LFileList[LLoopCnt], '.exe');
      if not FileExists(LexeName) then begin
        FileList.Add(LFileList[LLoopCnt]);
      end;
    end else begin
      FileList.Add(LFileList[LLoopCnt]);
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  RpCs̃\bh
//
//  pCvgpăRpCsbZ[Wǂݏo悤ɂĂ
//
//  []
//  dccPath    R}hRpC̃tpX
//  FlieList   RpCΏۂdprt@C̃Xg
//-----------------------------------------------------------------------------
function TForm1.ComplieProject(dccPath: string; FileList: TStringList): Integer;
var
  LProjName  : string;
  LOptionStr : string;
  LCmdLine   : TplCommandRedirect;
  LCmdStr    : string;
  LLoopCnt   : Integer;
  LStrList   : TStringList;
begin
  Screen.Cursor := crHourGlass;
  Result := 0;
  ControlsEnabled(Panel1, False);
  btnCancel.Enabled := True;

  Memo1.Clear;
  Update;
  FCancelFlag            := False;
  Label1.Caption        := IntToStr(0) + '/' + IntToStr(FileList.Count);
  ProgressBar1.Position := 0;
  ProgressBar1.Visible  := True;

  LCmdLine := TplCommandRedirect.Create;
  LStrList := TStringList.Create;

  try
    ProgressBar1.Min := 0;
    ProgressBar1.Max := FileList.Count;

    for LLoopCnt := 0 to FileList.Count - 1 do begin
      LOptionStr := CreateCommandLineStr(dccPath, FileList[LLoopCnt]);
      LProjName  := AnsiQuotedStr(FileList[LLoopCnt], '"');

      //-UIvVőΏۃvWFNg̃tH_w肵Ă邪܂
      //ȂvWFNĝŁCŃJgfBNgύXĂ݂
      //݂̂ƂOK̂悤ł
      SetCurrentDir(ExtractFileDir(FileList[LLoopCnt]));

      //G[Ȃƃt@C\Ȃ̂Œǉ
      Memo1.Lines.Add(FileList[LLoopCnt]);

      //vWFNgR}hCRpCŃRpC
      LCmdStr := dccPath + ' ' + LProjName + '' + LOptionStr;
      LStrList.Text := LCmdLine.GrabStdOutText(LCmdStr);
      if Trim(LStrList.Text) = '' then LStrList.Text := 'RpCɎs܂';
      Memo1.Lines.Add(LStrList.Text);
      Memo1.Lines.Add(sLineBreak);


      ProgressBar1.Position := LLoopCnt + 1;
      Label1.Caption := IntToStr(LLoopCnt + 1) + '/' + IntToStr(FileList.Count);
      ProgressBar1.Update;
      Label1.Update;

      Application.ProcessMessages;
      if FCancelFlag then break;
    end;
  finally
    FreeAndNil(LCmdLine);
    FreeAndNil(LStrList);
    //JgfBNg̃tH_ɖ߂
    SetCurrentDir(ExtractFileDir(Application.ExeName));

    ControlsEnabled(Panel1,True);
    btnCancel.Enabled := False;
  end;
  ProgressBar1.Visible := False;
  Screen.Cursor := crDefault;
end;

//-----------------------------------------------------------------------------
//  RpCIvV̕쐬֐
//  R}hRpC(dcc32.exe)͈ȉ̏ԂɃRpCIvV̐ݒǂ
//  ݒ̓I[oChĎgp
//  ̃\bhō쐬Ă̂(4)
//  ProjNamevWFNg̃tpX(dprt@C)
//  (Cu)pXƂāCRpCΏۂ̃t@C1̊Kw̃tH
//  _ǉĂ
//
//  (1) $(DELPHI)Bin܂$(BDS)Bindcc32.cfg
//  (2) JgfBNgdcc32.cfg
//  (3) RpCΏۃvWFNg̃fBNgdcc32.cfg
//  (4) R}hCŎw肵IvV
//
//  RpCIvV(Pipeɂo͂ɂe)
//  -A  jbg̃GCAXݒD
//  -B  č\zDDLL⃊\[Xt@C̏CvWFNgEXEɔfɂ
//      ɂ͍č\zKvD
//  -U  CupX̎wD̎;(Z~R)ŋ؂D
//      IDE[c[][IvV][Cu]^uɑ邪CR}h
//      CRpC̏ꍇ́C̃jbggpꍇC̃vWFNg
//      ̃tH_w肷KvD
//  -E  쐬EXEt@C̒uꏊDw肵ȂĂ.dprƓtH_
//      EXEt@Cł邪C̃IvVw肵ȂƁCDLLJgfB
//      Ng(ComplieAllProjet)ɂłĂ܂D
//  -R  \[Xt@CpXD
//  -H  qgbZ[W̕\(Pipeɏo͂)D
//  -W  xbZ[W̏o(Pipeɏo͂)
//  -Q  Quiet[hDRpC̃t@Cƍsԍ̕\ȂDN̒
//      쌠bZ[WƏĨRpCʂ̏񂾂\.G[
//      \(ŕ\ƂPipeɏo͂ƂӖ)D
//-----------------------------------------------------------------------------
function TForm1.CreateCommandLineStr(dccPath: string; ProjName: string): string;
var
  LTabName        : string;
  LConfilFileName : string;
  LIniFile        : TIniFile;
  LProductVer     : Double;
  LStrList        : TStringList;
  LStr            : string;
  LProjDir        : string;
  LLoopCnt        : Integer;
begin
  LProjDir := ExtractFileDir(ProjName);
  LStrList := TStringList.Create;

  LTabName        := TabControl1.Tabs[TabControl1.TabIndex];
  LConfilFileName := ExtractFilePath(Application.ExeName)
                  + 'LibPath' + LTabName + '.CFG';
  try
    LStrList.LoadFromFile(LConfilFileName);

    //qgƌx͑Ώۃjbgŕ\IvV鎞͖
    //ChekBox2͍č\z̎w
    if CheckBox2.Checked then LStr := LStr + ' -B';

    //ChekBox3̓qg\̎w
    if CheckBox3.Checked then LStr := LStr + ' -H+' else LStr := LStr + ' -H-';

    //ChekBox4͌x\̎w
    if CheckBox4.Checked then LStr := LStr + ' -W+' else LStr := LStr + ' -W-';

    LStr := LStr
         + ' -Q'
         + ' -E' + AnsiQuotedStr(LProjDir, '"')
         + ' -R' + AnsiQuotedStr(LProjDir, '"');

    //Delphi XE2ȍ~̏ꍇ
    //jbgXR[v(Delphi XE2̃vWFNgIvVRs[Xg)
    //ꂾł͕sĂ邩mȂ
    LIniFile := TIniFile.Create(FIniFileName);
    try
      LProductVer := LIniFile.ReadFloat(LTabName, 'ProductVer', 0);
      if LProductVer >= 15.99 then begin
        LStr := LStr + ' -NS'
             + 'Winapi'
             + ';System.Win'
             + ';Data.Win'
             + ';Datasnap.Win'
             + ';Web.Win;'
             + ';Soap.Win'
             + ';Xml.Win'
             + ';Bde'
             + ';System'
             + ';Xml'
             + ';Data'
             + ';Datasnap'
             + ';Web'
             + ';Soap'
             + ';Vcl'
             + ';Vcl.Imaging'
             + ';Vcl.Touch'
             + ';Vcl.Samples'
             + ';Vcl.Shell';
      end;
    finally
      FreeAndNil(LIniFile);
    end;

    //CupX̒ǉ
    LStr := LStr + ' -U';
    for LLoopCnt := 0 to LStrList.Count - 1 do begin
      if LLoopCnt = 0 then begin
        LStr := LStr + AnsiQuotedStr(LStrList[LLoopCnt], '"');
      end else begin
        LStr := LStr + ';' + AnsiQuotedStr(LStrList[LLoopCnt], '"');
      end;
    end;
    //ΏۃvWFNgƂ1̊Kw̃tH_ΏۂƂĒǉ
    Result := LStr
            + ';' + AnsiQuotedStr(LProjDir, '"')
            + ';' + AnsiQuotedStr(ExtractFileDir(LProjDir), '"');
  finally
    FreeAndNil(LStrList);
  end;
end;

//=============================================================================
//  [LZ]
//=============================================================================
procedure TForm1.btnCancelClick(Sender: TObject);
begin
  FCancelFlag := True;
end;

//-----------------------------------------------------------------------------
//  WCŎw肷Rg[̃Rg[EnabledvpeBݒ
//  TPanel̏ɍڂĂRg[TPanelDisalbeɂΑsɂȂ
//  oIʂȂ̂ŁCŐݒ
//-----------------------------------------------------------------------------
procedure TForm1.ControlsEnabled(WC: TWinControl; Flag: Boolean);
var
  LControl : TControl;
  LIndex   : Integer;
begin
  if WC.ControlCount = 0 then exit;
  for LIndex := 0 to WC.ControlCount - 1 do begin
    LControl := WC.Controls[LIndex];
    LControl.Enabled := Flag;
    if LControl is TWinControl then ControlsEnabled(TWinControl(LControl),Flag);
  end;
end;

//=============================================================================
//  ^uRg[̃^u؂ւ
//=============================================================================
procedure TForm1.TabControl1Change(Sender: TObject);
var
  LIniFile    : TIniFile;
  LConfigFile : string;
  LStrList    : TStringList;
  LTabName    : string;
begin
  LIniFile    := TIniFile.Create(FIniFileName);
  LTabName    := TabControl1.Tabs[TabControl1.TabIndex];
  LConfigFile := 'LibPath' + LTabName + '.CFG';

  try
    LIniFile.WriteString('Common', 'TabName', LTabName);
  finally
    FreeAndNil(LIniFile);
  end;

  //CupX̐ݒt@CȂΒĕۑ
  //߂ă^u؂芷ꍇ̂ݎs
  if not FileExists(LConfigFile) then begin
    LStrList := TStringList.Create;
    try
      //CupX̌o
      SetDefaultLibPath(LTabName, LConfigFile, LStrList);
      LStrList.SaveToFile(LConfigFile);
    finally
      FreeAndNil(LStrList);
    end;
  end;
end;

//=============================================================================
//  RpC̏ݒp̃`FbN{bNX̏ԂύX
//  Init@Cɕۑ
//=============================================================================
procedure TForm1.CheckBox1Click(Sender: TObject);
var
  LIniFile : TIniFile;
begin
  LIniFile := TIniFile.Create(FIniFileName);
  try
    LIniFile.WriteBool('Common', 'Checkbox1', CheckBox1.Checked);
    LIniFile.WriteBool('Common', 'Checkbox2', CheckBox2.Checked);
    LIniFile.WriteBool('Common', 'Checkbox3', CheckBox3.Checked);
    LIniFile.WriteBool('Common', 'Checkbox4', CheckBox4.Checked);
  finally
    FreeAndNil(LIniFile);
  end;
end;

//-----------------------------------------------------------------------------
//  DelphiIDEŐݒ肵Ă郉CupXǉ
//  CupX̎擾@킩Ȃ̂ŃWXg擾
//  dpX͒̕ǉȂ
//  $(DELPHI)$(BDS)͕ʕƂĈĂ
//
//  ႦDelphi7̏ꍇC$(DELPHI)C:\Program Files\Borland\Delphi7\bin͎
//  ɂ͓pXӖĂ邪Cł͏dĂ܂
//-----------------------------------------------------------------------------
procedure TForm1.SetDefaultLibPath(TabName, ConfigFileName: string;
  SL: TStringList);
var
  LIniFile : TIniFile;
  LReg     : TRegistry;
  LAppKey  : string;
  LAppItem : string;
begin
  //Init@CKEYlǂݏo
  //[gL[HKEY_CURRENT_USERƉ肵āCEXENKEYڂ擾
  LIniFile := TIniFile.Create(FIniFileName);
  try
    LAppKey := LIniFile.ReadString(TabName, 'AppKeyLib', '');
  finally
    FreeAndNil(LIniFile);
  end;

  LReg := TRegistry.Create;
  try
    LReg.Access  := KEY_READ;
    LReg.RootKey := HKEY_CURRENT_USER;
    LAppItem     := 'Search Path';

    SL.Sorted        := True;
    SL.Duplicates    := dupIgnore;
    SL.CaseSensitive := False;

    if LReg.OpenKey(LAppKey, False) then begin
      try
        SL.Delimiter       := ';';
        SL.StrictDelimiter := True;
        SL.DelimitedText   := LReg.ReadString(LAppItem);
      finally
        LReg.CloseKey;
      end;
    end;
  finally
    FreeAndNil(LReg);
  end;
end;

//-----------------------------------------------------------------------------
//  CXg[ςDelphi̊eo[W̏WFlbNX̃XgɊi[
//  XgɊi[̂Dephi̊eo[W̏i[郌R[h^
//-----------------------------------------------------------------------------
procedure GetDelphiVerList(AList: TList<TDelphiVerInfo>);

  procedure InitializeRecord(var AInfo: TDelphiVerInfo);
  begin
    AInfo.ProductVer  := 0.0;
    AInfo.AppFullPath := 'Empty';
    AInfo.RegKeyBase  := 'Empty';
    AInfo.VersionStr  := 'Empty';
    AInfo.Enable64bit := False;
  end;

const
  LArrayBDS : array [0..2] of string
              = ('\Borland\BDS', '\CodeGear\BDS', '\Embarcadero\BDS');
var
  LRegistry    : TRegistry;
  LKeyBDS      : string;
  LKeyEeachVer : string;
  LKeyNameList : TStringList;
  LKeyItemList : TStringList;
  LAppInfo     : TDelphiVerInfo;
  LTempValue   : string;
  LLoopCnt     : Integer;
  LLoopBDS     : Integer;
begin
  AList.Clear;

  LRegistry    := TRegistry.Create;
  LKeyNameList := TStringList.Create;
  LKeyItemList := TStringList.Create;

  try
    LRegistry.Access  := KEY_READ;
    LRegistry.RootKey := HKEY_LOCAL_MACHINE;

    //-------------------------------------------------------------------------
    // Delphi 2 - 7
    // Delphi 4 ܂ł͍ŏ̍ڂDelphi ̃o[W
    // Delphi 5 ͍ږ App EXẼtpX
    //-------------------------------------------------------------------------
    LKeyBDS := 'Software\Borland\Delphi';

    if LRegistry.OpenKey(LKeyBDS, False) then begin
      // ݂̃L[̊Kw̃L[̈ꗗ擾
      // ̃L[Delphi̊eo[WƂ̃L[
      LRegistry.GetKeyNames(LKeyNameList);

      for LLoopCnt := 0 to LKeyNameList.Count - 1 do begin
        LKeyEeachVer := LKeyBDS + PathDelim + LKeyNameList[LLoopCnt];

        LRegistry.CloseKey;
        InitializeRecord(LAppInfo);

        if LRegistry.OpenKey(LKeyEeachVer, False) then begin
          LAppInfo.ProductVer := StrToFloat(LKeyNameList[LLoopCnt]);

          if LAppInfo.ProductVer < 5.0 then begin
            // ݂DelphĩL[̊eږ(O:WXgGg)ꗗ擾
            LRegistry.GetValueNames(LKeyItemList);
            if LKeyItemList.Count < 1 then Continue;
            LAppInfo.AppFullPath  := LRegistry.ReadString(LKeyItemList[0]);
          end else begin
            if not LRegistry.ValueExists('App') then Continue;
            LAppInfo.AppFullPath := LRegistry.ReadString('App');
          end;

          // Delphi ̃o[W̍쐬
          // _ȉ 0 ̎͐Ƃ
          LTempValue := Trim(LKeyNameList[LLoopCnt]);
          if RightStr(LTempValue, 2) = '.0' then begin
            LTempValue := LeftStr(LTempValue, 1);
          end;

          LAppInfo.VersionStr := 'Delphi ' + LTempValue;
          LAppInfo.RegKeyBase := LKeyEeachVer;

          // WFlbNX̃XgɃR[h^̃f[^ǉ
          AList.Add(LAppInfo);
        end;
      end;
    end;
    LRegistry.CloseKey;


    //-------------------------------------------------------------------------
    // Delphi 2005 ȍ~
    //-------------------------------------------------------------------------
    for LLoopBDS := 0 to Length(LArrayBDS) - 1 do begin
      LKeyBDS := 'Software' + LArrayBDS[LLoopBDS];

      if LRegistry.OpenKey(LKeyBDS, False) then begin
        // ݂̃L[̊Kw̃L[̈ꗗ擾
        // ̃L[Delphi̊eo[WƂ̃L[
        LRegistry.GetKeyNames(LKeyNameList);

        for LLoopCnt := 0 to LKeyNameList.Count - 1 do begin
          LKeyEeachVer := LKeyBDS + PathDelim + LKeyNameList[LLoopCnt];

          LRegistry.CloseKey;
          InitializeRecord(LAppInfo);

          if LRegistry.OpenKey(LKeyEeachVer, False) then begin
            if not LRegistry.ValueExists('App') then Continue;
            LAppInfo.AppFullPath := LRegistry.ReadString('App');

            if LRegistry.ValueExists('ProductVersion') then begin
              LAppInfo.ProductVer := StrToFloat(LRegistry.ReadString('ProductVersion'));
            end;

            LRegistry.CloseKey;
            // Delphi XE,Delphi XE5,..̕擾
            if LRegistry.KeyExists(LKeyEeachVer + '\Personalities') then begin
              if LRegistry.OpenKey(LKeyEeachVer + '\Personalities', False) then begin
                if LRegistry.ValueExists('Delphi.Win32') then begin
                  LAppInfo.VersionStr := LRegistry.ReadString('Delphi.Win32');
                end;
              end;
            end;

            LAppInfo.RegKeyBase := LKeyEeachVer;

            // 64 rbg̊J\𒲍
            if ContainsText(LKeyBDS, 'Embarcadero\BDS') then begin
              LRegistry.CloseKey;
              if LRegistry.KeyExists(LKeyEeachVer + '\Library\Win64') then begin
                // 64rbgpWindowsAvJ\ȏꍇTrue
                LAppInfo.Enable64bit := True;
              end else begin
                LAppInfo.Enable64bit := False;
              end;
            end;

            AList.Add(LAppInfo);
          end;
        end;
      end;
      LRegistry.CloseKey;
    end;

    //---------------------------------------------------------
    //  v_Ngo[W̒lŃXg\[g
    //  TComparer֌W̎gpɂusesGenerics.DefaultsKv
    //---------------------------------------------------------
    AList.Sort(TComparer<TDelphiVerInfo>.Construct(
      function(const Left, Right: TDelphiVerInfo): Integer
      begin
        Result := Trunc((Left.ProductVer - Right.ProductVer) * 10);
      end)
    );
  finally
    FreeAndNil(LRegistry);
    FreeAndNil(LKeyNameList);
    FreeAndNil(LKeyItemList);
  end;
end;

//-----------------------------------------------------------------------------
//  32rbgWindows64rbgWindows𒲂ׂ֐
//  64rbgłWindows̏ꍇTrueԂ
//-----------------------------------------------------------------------------
function Is64bitWindows: Boolean;
var
  Wow64Proc : function(hProcess: THandle; var Wow64: BOOL): BOOL stdcall;
  RetFlag   : LongBool;
begin
  @Wow64Proc := GetProcAddress(GetModuleHandle('Kernel32.dll'), 'IsWow64Process');
  if @Wow64Proc <> nil then begin
    Wow64Proc(GetCurrentProcess, RetFlag);

    if SizeOf(THandle) = 4 then begin
      Result := RetFlag;
    end else
    if SizeOf(THandle) = 8 then begin
      Result := True;
    end;
  end else begin
    //Windows XP64rbgł
    Result := CheckWin32Version(5, 2);
  end;
end;

end.
