//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  cpxR|[lg
//
//  TLabelpx
//  c̏ꍇCShowAccelChar̐ݒ͖(FalseƓ)
//  WordWrap
//  RpcɂȂ̂Œ
//
//  ǉvpeB
//  Vertical  TrueŏcCFalseȂTLabel̂
//  Picture   摜DAutoSizeTureȂ摜̃TCYɂȂDFalseȂ猻݂̃TC
//            YStretchDrawD
//            PictureL̎̓LvV͕\ȂD
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2004N0725 `
//  2013N1102
//    EWindows 7 U64(SP1) + Delphi 7 XE ProœmF
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plVertLabel;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, StdCtrls;

type
  TplVertLabel = class(TLabel)
  private
    { Private 錾 }
    FVertical : Boolean;
    FPicture  : TPicture;
    procedure SetVertical(const Value: Boolean);
    procedure SetPicture(const Value: TPicture);
  protected
    { Protected 錾 }
    procedure Paint; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published 錾 }
    property Vertical : Boolean  read FVertical write SetVertical;
    property Picture  : TPicture read FPicture  write SetPicture;
  end;

procedure Register;

implementation

{ TplVertLabel }

//=============================================================================
//  Create
//  NX(R|[lg)̃RXgN^
//  PicturevpeB̃CX^X(TPictureIuWFNg)𐶐
//=============================================================================
constructor TplVertLabel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FPicture := TPicture.Create;
end;

//=============================================================================
//  Destroy
//  TPictureIuWFNg̉
//=============================================================================
destructor TplVertLabel.Destroy;
begin
  FreeAndNil(FPicture);
  inherited;
end;

//=============================================================================
//  VerticalvpeB̐ݒp\bh
//  c̐ݒ
//
//  R|[lg̃vpeBCR|[lgŎgpꍇ
//  O[oϐFVerticalgp
//  OŎgpVerticalŎgpƁCēx̂̃\bhsC
//  ꍇɂĂ͏zQƂƂȂĂ܂Ƃ
//
//  {R[h͂h~Ӗłl̎͐ݒsȂ悤ɂĂ
//=============================================================================
procedure TplVertLabel.SetVertical(const Value: Boolean);
begin
  if Value <> FVertical then begin
    FVertical := Value;
    //Rĕ`悪Kv(Paint\bhs)
    Invalidate;
  end;
end;

//=============================================================================
//  PicturevpeB̐ݒp\bh
//  IuWFNg^̃vpeB̐ݒAssigngp
//=============================================================================
procedure TplVertLabel.SetPicture(const Value: TPicture);
begin
  FPicture.Assign(Value);
end;

//=============================================================================
//  TLabel.Paint\bh̃I[oCh
//  TplVertLabel.Canvasւ̕`揈
//
//  TextOutgpĕ`悵Ă邽߂̐͂邪Cʏ̗prɂ͏\ƍl
//  XɍׂKvł΁CDrawText, DrawTextExgp낤
//=============================================================================
procedure TplVertLabel.Paint;
var
  LfMode   : Integer;
  LLogFont : TLogFont;
  LPosX    : Integer;
  LPosY    : Integer;
begin
  //PicturevpeBLȏꍇ
  if Assigned(FPicture.Graphic) then begin
    //AutoSizeTruȅꍇ
    if AutoSize then begin
      SetBounds(Self.Left, Self.Top, FPicture.Width, FPicture.Height);
      Canvas.Draw(0, 0, FPicture.Graphic);
    end else begin
      Canvas.StretchDraw(Rect(0, 0, Width, Height), FPicture.Graphic);
    end;
    //摜\ꍇ̓eLXg͕`悵Ȃ̂ŏI
    exit;
  end;

  //c̎̏
  if FVertical then begin
    //wiF
    if not Transparent then begin
      Canvas.Brush.Color := Self.Color;
      Canvas.Brush.Style := bsSolid;
      Canvas.FillRect(ClientRect);
    end;
    Canvas.Brush.Style := bsClear;

    //ctHg쐬āCv90x]tHgƂ
    Canvas.Font.Assign(Self.Font);
    Canvas.Font.Name := '@' + Self.Font.Name;
    GetObject(Canvas.Font.Handle, SizeOf(LLogFont), @LLogFont);
    LLogFont.lfEscapement := -900;
    Canvas.Font.Handle := CreateFontIndirect(LLogFont);

    //AutoSizeTruȅꍇ
    if AutoSize then begin
      SetBounds(Self.Left,
                Self.Top,
                Canvas.TextHeight(Caption),
                Canvas.TextWidth(Caption));
    end;

    LfMode := 0;
    LPosX  := 0;
    LPosY  := 0;

    //̈ʒu
    if Alignment = taLeftJustify then begin
      LfMode := LfMode or VTA_LEFT;
    end else
    if Alignment = taCenter then begin
      LPosX  := (Width + Canvas.TextHeight(Caption)) div 2;
    end else
    if Alignment = taRightJustify then begin
      LPosX  := Width;
      LfMode := LfMode or VTA_RIGHT;
    end;

    //c̈ʒu
    if Layout = tlCenter then begin
      LPosY  := (Height - Canvas.TextWidth(Caption)) div 2;
    end else
    if Layout = tlTop then begin
      LfMode := LfMode or VTA_TOP;
    end else
    if Layout = tlBottom then begin
      LPosY  := Height;
      LfMode := LfMode or VTA_BOTTOM;
    end;

    //ACg̐ݒ
    SetTextAlign(Canvas.Handle, LfMode);

    if not Enabled then begin
      Canvas.Font.Color := clBtnHighlight;
      Canvas.TextOut(LPosX + 1, LPosY + 1, Caption);
      Canvas.Font.Color := clBtnShadow;
    end;
    Canvas.TextOut(LPosX, LPosY, Caption);
  //̎͌p̏s
  end else begin
    {AutoSizeTruȅꍇ}
    if AutoSize then begin
      SetBounds(Self.Left,
                Self.Top,
                Canvas.TextWidth(Caption),
                Canvas.TextHeight(Caption));
    end;
    inherited;
  end;
end;

//=============================================================================
//  R|[lgo^
//  R|[lgpbg[plXRAY]Ƃ^uTplVertLableœo^
//  w肵^uȂꍇ́CIɍ쐬
//=============================================================================
procedure Register;
begin
  RegisterComponents('plXRAY', [TplVertLabel]);
end;

end.
